CodeForces 616C The Labyrinth(DFS)

题意给你n行m列的矩阵,矩阵*表示障碍,.表示空地对于每一个障碍,让你输出去掉这个障碍之后,这个点所在的连通块的大小是多少

思路:DFS...


#include<bits/stdc++.h>
using namespace std;
const int maxn = 1005;
char mp[maxn][maxn];
int cc[maxn][maxn];
int num[maxn*maxn];
int vis[maxn][maxn];
int dir[4][2]={{0,1},{0,-1},{1,0},{-1,0}};
int n,m;
set<int>s;
set<int>::iterator it;
void dfs(int x,int y,int c)
{
	cc[x][y]=c;
	num[c]++;
	for (int i = 0;i<4;i++)
	{
		int dx = x+dir[i][0];
		int dy = y+dir[i][1];
		if (dx>=n || dx<0 || dy<0 || dy>=m)
			continue;
		if (cc[dx][dy] || mp[dx][dy]!='.')
			continue;
		vis[dx][dy]=1;
		dfs(dx,dy,c);
	}
}
int solve(int x,int y)
{
	s.clear();
	int ans = 0;
	for (int i = 0;i<4;i++)
	{
		int dx = x+dir[i][0];
		int dy = y+dir[i][1];
		if (dx>=n || dx<0 || dy<0 || dy>=m)
			continue;
		if (mp[dx][dy]!='.')
			continue;
		s.insert(cc[dx][dy]);
	}
	for (it = s.begin();it!=s.end();it++)
	{
		ans+=num[*it];
	}
	return ans;
}
int main()
{
     scanf("%d%d",&n,&m);
	 for (int i = 0;i<n;i++)
		 scanf("%s",mp[i]);
	 int c = 1;
	 for (int i = 0;i<n;i++)
		 for (int j = 0;j<m;j++)
			 if (cc[i][j]==0 && mp[i][j]=='.')
			 {
				 num[c]=0;
				 dfs(i,j,c);
				 c++;
			 }
	 for (int i = 0;i<n;i++)
		 for (int j = 0;j<m;j++)
			 if (mp[i][j]=='*')
			 {
				 int ans = (solve(i,j)+1)%10;
				 mp[i][j]='0'+ans;
			 }
	 for (int i = 0;i<n;i++)
		 printf("%s\n",mp[i]);
}


Description

You are given a rectangular field of n × m cells. Each cell is either empty or impassable (contains an obstacle). Empty cells are marked with '.', impassable cells are marked with '*'. Let's call two empty cells adjacent if they share a side.

Let's call a connected component any non-extendible set of cells such that any two of them are connected by the path of adjacent cells. It is a typical well-known definition of a connected component.

For each impassable cell (x, y) imagine that it is an empty cell (all other cells remain unchanged) and find the size (the number of cells) of the connected component which contains (x, y). You should do it for each impassable cell independently.

The answer should be printed as a matrix with n rows and m columns. The j-th symbol of the i-th row should be "." if the cell is empty at the start. Otherwise the j-th symbol of the i-th row should contain the only digit —- the answer modulo 10. The matrix should be printed without any spaces.

To make your output faster it is recommended to build the output as an array of n strings having length m and print it as a sequence of lines. It will be much faster than writing character-by-character.

As input/output can reach huge size it is recommended to use fast input/output methods: for example, prefer to use scanf/printf instead ofcin/cout in C++, prefer to use BufferedReader/PrintWriter instead of Scanner/System.out in Java.

Input

The first line contains two integers n, m (1 ≤ n, m ≤ 1000) — the number of rows and columns in the field.

Each of the next n lines contains m symbols: "." for empty cells, "*" for impassable cells.

Output

Print the answer as a matrix as described above. See the examples to precise the format of the output.

Sample Input

Input
3 3
*.*
.*.
*.*
Output
3.3
.5.
3.3
Input
4 5
**..*
..***
.*.*.
*.*.*
Output
46..3
..732
.6.4.
5.4.3

Hint

In first example, if we imagine that the central cell is empty then it will be included to component of size 5 (cross). If any of the corner cell will be empty then it will be included to component of size 3 (corner).



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值